//##************************
//##* This program is free software; you can use it, redistribute it and/or modify it
//##* under the terms of the GNU General Public License version 2 as published by the
//##* Free Software Foundation. The full text of the GNU General Public License
//##* version 2 can be found in the file named 'COPYING' that accompanies this
//##* program. This source code is (C)copyright Geoffrey French 1999-2007.
//##************************
#ifndef PYGRAPHVIEWLINKCURVETABLE_CPP__
#define PYGRAPHVIEWLINKCURVETABLE_CPP__

#include <GraphViewHelper/GraphViewLinkCurveTable.h>

#include <boost/python.hpp>
using namespace boost::python;


void export_GraphViewLinkCurveTable()
{
	class_<GraphViewLinkCurveTable>( "GraphViewLinkCurveTable", init<>() )
		.def( "addLinkCurve", &GraphViewLinkCurveTable::addLinkCurve )
		.def( "setLinkCurve", &GraphViewLinkCurveTable::setLinkCurve )
		.def( "removeLinkCurve", &GraphViewLinkCurveTable::removeLinkCurve )
		.def( "getIntersectingLinkList", &GraphViewLinkCurveTable::getIntersectingLinkList )
		.def( "getLinkClosestToPoint", &GraphViewLinkCurveTable::getLinkClosestToPoint );
}


#endif
