##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
import pygtk
pygtk.require( '2.0' )
import gobject


from gSculpt.Util.SignalSlot import Signal



def queueEvent(func):
	global __queuedEventSignal
	__queuedEventSignal.connect( func )


def dequeueEvent(func):
	global __queuedEventSignal
	__queuedEventSignal.disconnect( func )




def __queuedEventSignalConnectionListener(signal):
	if signal.hasConnections():
		__queuedEventAddIdle()
	else:
		__queuedEventRemoveIdle()


def __queuedEventAddIdle():
	global __queuedEventIdleHandle
	__queuedEventIdleHandle = gobject.idle_add( __queuedEventIdleFunction )

def __queuedEventRemoveIdle():
	global __queuedEventIdleHandle
	gobject.source_remove( __queuedEventIdleHandle )
	__queuedEventIdleHandle = None



def __queuedEventIdleFunction():
	__queuedEventSignal.emit()
	__queuedEventSignal.disconnectAll()
	__queuedEventIdleHandle = None
	return False




__queuedEventSignal = Signal()
__queuedEventSignal.setConnectionListener( __queuedEventSignalConnectionListener )
__queuedEventIdleHandle = None

