##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from ObjectSource import ObjectSource



class CachedObjectSource (ObjectSource):
	def __init__(self):
		super( CachedObjectSource, self ).__init__()
		self._cacheObject = None
		self._bCacheValid = False


	def getValue(self):
		if not self._bCacheValid:
			self._cacheObject = self._p_evaluateSource()
			self._bCacheValid = True

		return self._cacheObject


	def _p_invalidateCache(self):
		if self._bCacheValid:
			self._cacheObject = None
			self._bCacheValid = False
			self.changedSignal.emit()
			return True
		else:
			return False


	def _p_evaluateSource(self):
		assert False, 'abstract'


	def _p_isCached(self):
		return self._bCacheValid