##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.Tool import Tool

from gSculpt.Kernel.DB import Row
from gSculpt.Kernel.DBEdit import RowEditContext, RowEditorClass, RowEditor





class RowEditorToolClass (RowEditorClass):
	pass






class RowEditorTool (Tool.Tool, RowEditor):
	"Function tool base class"
	__metaclass__ = RowEditorToolClass

	rowClass = Row
	pageTitle = 'tool'
	titleText = 'RowEditorTool'



	def __init__(self):
		"Constructor"
		super( RowEditorTool, self ).__init__()

		self.setTitleWidgetText( self.titleText )

		self.pageTitle = type(self).pageTitle


	def createUI(self):
		super( RowEditorTool, self ).createUI()
		self.createRowEditorUI()


	def layoutUI(self):
		super( RowEditorTool, self ).layoutUI()
		self.layoutRowEditorUI()
		self._o_packContents( self.getRowEditorWidget() )


	def destroyUI(self):
		super( RowEditorTool, self ).destroyUI()
		self.destroyRowEditorUI()



	def initialise(self):
		super( RowEditorTool, self ).initialise()
		self.initialiseRowEditorUI()


	def shutdown(self):
		super( RowEditorTool, self ).shutdown()
		self.shutdownRowEditorUI()



	def _o_installAccelerators(self, accels):
		super( RowEditorTool, self )._o_installAccelerators( accels )
		self.rowEditorInstallAccelerators( accels )


	def _o_uninstallAccelerators(self, accels):
		super( RowEditorTool, self )._o_uninstallAccelerators( accels )
		self.rowEditorUninstallAccelerators( accels )



	def onPageSwitchIn(self):
		super( RowEditorTool, self ).onPageSwitchIn()
		self.rowEditorInstallEventHandlers()

	def onPageSwitchOut(self):
		super( RowEditorTool, self ).onPageSwitchOut()
		self.rowEditorUninstallEventHandlers()



