##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.FileIO.IOXml import IOXmlEnum, ioObjectFactoryRegisterPrimitive

from gSculpt.Kernel.DB import Field, registerFieldType

from gSculpt.Mesh.Mesh import MeshPreserveNormalSharpness





# XML IO for MeshPreserveNormalSharpness

preserveSharpnessIOXmlEnum = IOXmlEnum( MeshPreserveNormalSharpness, 'MeshPreserveNormalSharpness', MeshPreserveNormalSharpness.IF_SHARP )
preserveSharpnessIOXmlEnum.value( MeshPreserveNormalSharpness.PRESERVE, 'preserve' )
preserveSharpnessIOXmlEnum.value( MeshPreserveNormalSharpness.IF_SHARP, 'if_sharp' )
preserveSharpnessIOXmlEnum.value( MeshPreserveNormalSharpness.SMOOTH, 'smooth' )

ioXmlReadMeshPreserveNormalSharpnessProp = preserveSharpnessIOXmlEnum.propReader
ioXmlReadMeshPreserveNormalSharpnessNode = preserveSharpnessIOXmlEnum.nodeReader
ioXmlWriteMeshPreserveNormalSharpnessProp = preserveSharpnessIOXmlEnum.propWriter
ioXmlWriteMeshPreserveNormalSharpnessNode = preserveSharpnessIOXmlEnum.nodeWriter

ioObjectFactoryRegisterPrimitive( 'MeshPreserveNormalSharpness', MeshPreserveNormalSharpness )


# Field for MeshPreserveNormalSharpness

class MeshPreserveNormalSharpnessField (Field):
	valueClass = MeshPreserveNormalSharpness
	defaultValue = MeshPreserveNormalSharpness.IF_SHARP
	xmlNodeValueReader = ioXmlReadMeshPreserveNormalSharpnessNode
	xmlNodeValueWriter = ioXmlWriteMeshPreserveNormalSharpnessNode

registerFieldType( MeshPreserveNormalSharpness, MeshPreserveNormalSharpnessField )

