##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.Math.Math import Plane, Vector3

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *

from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSFunctionTool import *
from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool

from gSculpt.Mesh.Mesh import GSProductMesh




class ProcMeshMirror (GSProcedure):
	description = _( 'Mirror' )

	inputClass = GSProductMesh
	outputClass = GSProductMesh

	def procedureInvoke(self, inputObject, errorHandler):
		inputObject.mirror( inputObject.virtualMirrorPlane.plane )
		inputObject.bVirtualMirrorEnabled = False
		return inputObject




class ToolMeshMirror (GSProcedureTool):
	row = RowRefColumn( ProcMeshMirror )

	functionClass = ProcMeshMirror
	pageTitle = _( 'Mirror' )
	titleText = _( 'Mirror' )

	layout = FormLayoutFactory()
	layout.row()  <<  _( 'Note: virtual mirror disabled' )
	layout.row()  <<  _( 'as a side effect' )
	layout.row()
	layout.finalise()
