##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh



class ProcMeshFillEdges (GSProcedure):
	description = _( 'Fill edges' )

	inputClass = GSProductMesh

	def procedureInvoke(self, inputObject, errorHandler):
		inputObject.fillMarkedEdges()
		return inputObject



class ToolMeshFillEdges (GSProcedureTool):
	row = RowRefColumn( ProcMeshFillEdges )

	functionClass = ProcMeshFillEdges
	pageTitle = _( 'Fill' )
	titleText = _( 'Fill edges' )

	layout = FormLayoutFactory()
	layout.row()  <<  _( 'Will not work if any non-boundary' )
	layout.row()  <<  _( 'edges are marked.' )
	layout.row()
	layout.row()  <<  _( 'All closed edge runs will be filled.' )
	layout.row()  <<  _( 'Will fill up to 2 open edge runs.' )
	layout.row()
	layout.finalise()
