##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool

from gSculpt.Manipulator.ColumnManipulators import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh



class ProcMeshNConnectEdges (GSProcedure):
	description = _( 'N-Connect edges' )

	numCuts = FieldColumn( int, 1 )

	inputClass = GSProductMesh

	def procedureInvoke(self, inputObject, errorHandler):
		inputObject.nConnectMarkedEdges( self.numCuts + 1 )
		return inputObject



class ToolMeshNConnectEdges (GSProcedureTool):
	row = RowRefColumn( ProcMeshNConnectEdges )

	functionClass = ProcMeshNConnectEdges
	pageTitle = _( 'N-Conn.' )
	titleText = _( 'N-Connect Edges' )

	numCutsEntry = IntColumnEditEntry( row.numCuts, 1, 1048576, 1, 10 )

	numCutsManip = IntColumnScrollManipulator( row.numCuts, 1, 1048576 )
	numCutsManip.enable()

	layout = FormLayoutFactory()
	layout.row()  <<  _( 'Use the scroll wheel to' )
	layout.row()  <<  _( 'change the number of cuts' )
	layout.row()
	layout.row()  <<  _( 'Num. cuts:' )  <<  numCutsEntry.entry
	layout.row()
	layout.finalise()
