##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh



class ProcMeshSelectEdgeBoundary (GSProcedure):
	description = _( 'Select edge boundary' )

	inputClass = GSProductMesh

	def procedureInvoke(self, inputObject, errorHandler):
		inputObject.markEdgeBoundary()
		return inputObject



class ToolMeshSelectEdgeBoundary (GSProcedureTool):
	row = RowRefColumn( ProcMeshSelectEdgeBoundary )

	functionClass = ProcMeshSelectEdgeBoundary
	pageTitle = _( 'Boundary' )
	titleText = _( 'Select Edge Boundary' )
