##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh



class ProcMeshSelectEdgeLoop (GSProcedure):
	description = _( 'Select edge loop' )

	bStopAtMarkedFaces = FieldColumn( bool, False )
	bCrossFacesMultipleTimes = FieldColumn( bool, True )

	inputClass = GSProductMesh

	def procedureInvoke(self, inputObject, errorHandler):
		inputObject.markEdgeLoop( self.bStopAtMarkedFaces, self.bCrossFacesMultipleTimes )
		return inputObject



class ToolMeshSelectEdgeLoop (GSProcedureTool):
	row = RowRefColumn( ProcMeshSelectEdgeLoop )

	functionClass = ProcMeshSelectEdgeLoop
	pageTitle = _( 'Loop' )
	titleText = _( 'Select Edge Loop' )

	bStopAtMarkedFacesCheck = BoolColumnEditCheck( row.bStopAtMarkedFaces, _( 'Stop at marked faces' ) )
	bCrossFacesMultipleTimesCheck = BoolColumnEditCheck( row.bCrossFacesMultipleTimes, _( 'Cross faces multiple times' ) )

	layout = FormLayoutFactory()
	layout.row()  <<  bStopAtMarkedFacesCheck.check
	layout.row()  <<  bCrossFacesMultipleTimesCheck.check
	layout.row()
	layout.finalise()
