##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool

from gSculpt.Manipulator.ColumnManipulators import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh



class ProcMeshSpinEdges (GSProcedure):
	description = _( 'Spin edges' )

	turns = FieldColumn( int, 0 )

	inputClass = GSProductMesh

	def procedureInvoke(self, inputObject, errorHandler):
		inputObject.spinMarkedEdges( self.turns )
		return inputObject



class ToolMeshSpinEdges (GSProcedureTool):
	row = RowRefColumn( ProcMeshSpinEdges )

	functionClass = ProcMeshSpinEdges
	pageTitle = _( 'Spin' )
	titleText = _( 'Spin Edges' )

	turnsEntry = IntColumnEditEntry( row.turns, -1048576, 1048576, 1, 10 )

	turnsManip = IntColumnScrollManipulator( row.turns, -1048576, 1048576 )
	turnsManip.enable()

	layout = FormLayoutFactory()
	layout.row()  <<  _( 'Use the scroll wheel to' )
	layout.row()  <<  _( 'change the number of turns' )
	layout.row()
	layout.row()  <<  _( 'Turns:' )  <<  turnsEntry.entry
	layout.row()
	layout.finalise()
