##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool

from gSculpt.PolyBlend.PolyBlendComponent import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh, MeshWeldStyle

from gSculpt.MeshTools.MeshEdit.MeshWeldStyle import *



class ProcMeshWeldFaces (GSProcedure):
	description = _( 'Weld faces' )

	blend = CompositeColumn( PolyBlendComponent )
	style = FieldColumn( MeshWeldStyle, MeshWeldStyle.MIDPOINT )


	inputClass = GSProductMesh

	def procedureInvoke(self, inputObject, errorHandler):
		inputObject.weldMarkedFaces( self.blend.makePolyBlend(), self.style )
		return inputObject



class ToolMeshWeldFaces (GSProcedureTool):
	row = RowRefColumn( ProcMeshWeldFaces )

	functionClass = ProcMeshWeldFaces
	pageTitle = _( 'Weld' )
	titleText = _( 'Weld Faces' )

	blendEdit = PolyBlendComponentColumnEdit( row.blend )
	styleRadio = MeshWeldStyleColumnEditRadioGroup( row.style )

	layout = FormLayoutFactory()
	layout.block( 4 )  <<  blendEdit.rowEditor
	layout.row()
	layout.row()  <<  _( 'Style:' )
	layout.row()  <<  styleRadio.midPoint
	layout.row()  <<  styleRadio.a
	layout.row()  <<  styleRadio.b
	layout.row()
	layout.finalise()
