##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.Math.Math import Vector3

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh, MeshTransformation




class ProcMeshEditMove (GSProcedure):
	description = _( 'Abstract move' )

	translation = FieldColumn( Vector3, Vector3() )

	inputClass = GSProductMesh



class ToolMeshEditMove (GSProcedureTool):
	row = RowRefColumn( ProcMeshEditMove )

	functionClass = ProcMeshEditMove
	pageTitle = _( 'Move' )
	titleText = _( 'Abstract Move' )

	translationEntry = Vector3ColumnEditEntry( row.translation, -1.0e8, 1.0e8, 0.1, 10.0, 4 )

	layout = FormLayoutFactory()
	layout.row()  <<  _( 'Move:' )
	layout.row()  <<  'X:'  <<  translationEntry.x
	layout.row()  <<  'Y:'  <<  translationEntry.y
	layout.row()  <<  'Z:'  <<  translationEntry.z
	layout.row()
	layout.finalise()
