##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.Math.Math import Vector3, Matrix4, Quaternion

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh




class ProcMeshEditRotate (GSProcedure):
	description = _( 'Abstract rotate' )

	bPerGroup = FieldColumn( bool, True )
	rotation = FieldColumn( Quaternion, Quaternion( 0.0, 0.0, 0.0, 1.0 ) )

	inputClass = GSProductMesh




class ToolMeshEditRotate (GSProcedureTool):
	row = RowRefColumn( ProcMeshEditRotate )

	functionClass = ProcMeshEditRotate
	pageTitle = _( 'Rotate' )
	titleText = _( 'Abstract Rotate' )

	bPerGroupCheck = BoolColumnEditCheck( row.bPerGroup, _( 'Per group' ) )
	rotationEntry = QuaternionColumnEditEntry( row.rotation )

	layout = FormLayoutFactory()
	layout.row()  <<  bPerGroupCheck.check
	layout.row()
	layout.row()  <<  _( 'Rotate:' )
	layout.row()  <<  'X:'  <<  rotationEntry.x
	layout.row()  <<  'Y:'  <<  rotationEntry.y
	layout.row()  <<  'Z:'  <<  rotationEntry.z
	layout.row()
	layout.finalise()
