##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.Math.Math import Vector3

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh




class ProcMeshEditScale (GSProcedure):
	description = _( 'Abstract scale' )

	bPerGroup = FieldColumn( bool, True )
	scale = FieldColumn( Vector3, Vector3( 1.0, 1.0, 1.0 ) )

	inputClass = GSProductMesh




class ToolMeshEditScale (GSProcedureTool):
	row = RowRefColumn( ProcMeshEditScale )

	functionClass = ProcMeshEditScale
	pageTitle = _( 'Scale' )
	titleText = _( 'Abstract scale' )

	bPerGroupCheck = BoolColumnEditCheck( row.bPerGroup, _( 'Per group' ) )
	scaleEntry = Vector3ColumnEditEntry( row.scale, -1.0e8, 1.0e8, 0.001, 0.1, 4 )

	layout = FormLayoutFactory()
	layout.row()  << bPerGroupCheck.check
	layout.row()
	layout.row()  <<  _( 'Scale:' )
	layout.row()  <<  'X:'  <<  scaleEntry.x
	layout.row()  <<  'Y:'  <<  scaleEntry.y
	layout.row()  <<  'Z:'  <<  scaleEntry.z
	layout.row()
	layout.finalise()
