##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from copy import deepcopy

from gSculpt.UI.FormLayout import FormLayoutFactory

from gSculpt.Kernel.DB import *
from gSculpt.ProceduralCore.GSProcedure import *

from gSculpt.ProceduralTool.GSProcedureTool import GSProcedureTool
from gSculpt.Kernel.ColumnEditors import *

from gSculpt.Mesh import Mesh
from gSculpt.Mesh.Mesh import GSProductMesh



class ProcMeshConnectVertices (GSProcedure):
	description = _( 'Connect vertices' )

	bMarkedFacesOnly = FieldColumn( bool, False )
	bMarkCutEdges = FieldColumn( bool, True )

	inputClass = GSProductMesh

	def procedureInvoke(self, inputObject, errorHandler):
		inputObject.connectMarkedVertices( self.bMarkedFacesOnly, self.bMarkCutEdges )
		return inputObject



class ToolMeshConnectVertices (GSProcedureTool):
	row = RowRefColumn( ProcMeshConnectVertices )

	functionClass = ProcMeshConnectVertices
	pageTitle = _( 'Connect' )
	titleText = _( 'Connect Vertices' )

	bMarkedFacesOnlyCheck = BoolColumnEditCheck( row.bMarkedFacesOnly, _( 'Marked faces only' ) )
	bMarkCutEdgesCheck = BoolColumnEditCheck( row.bMarkCutEdges, _( 'Mark cut edges' ) )

	layout = FormLayoutFactory()
	layout.row()  <<  bMarkedFacesOnlyCheck.check
	layout.row()  <<  bMarkCutEdgesCheck.check
	layout.row()
	layout.finalise()
