##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.FileIO.IOXml import IOXmlEnum, ioObjectFactoryRegisterPrimitive

from gSculpt.Kernel.Enum import Enum
from gSculpt.Kernel.Variable import VarInterface, Variable
from gSculpt.Kernel.DB import Field, registerFieldType



class MeshEditComponent (Enum):
	VERTICES = 0
	EDGES = 1
	FACES = 2



targetIOXmlEnum = IOXmlEnum( MeshEditComponent, 'MeshEditComponent', MeshEditComponent.VERTICES )
targetIOXmlEnum.value( MeshEditComponent.VERTICES, 'vertices' )
targetIOXmlEnum.value( MeshEditComponent.EDGES, 'edges' )
targetIOXmlEnum.value( MeshEditComponent.FACES, 'faces' )

ioXmlReadMeshEditComponentProp = targetIOXmlEnum.propReader
ioXmlReadMeshEditComponentNode = targetIOXmlEnum.nodeReader
ioXmlWriteMeshEditComponentProp = targetIOXmlEnum.propWriter
ioXmlWriteMeshEditComponentNode = targetIOXmlEnum.nodeWriter

ioObjectFactoryRegisterPrimitive( 'MeshEditComponent', MeshEditComponent )



# Variables and fields for MeshEditComponent

class MeshEditComponentVarInterface (VarInterface):
	valueClass = MeshEditComponent


class MeshEditComponentVar (Variable):
	valueClass = MeshEditComponent


class MeshEditComponentField (Field):
	valueClass = MeshEditComponent
	defaultValue = MeshEditComponent.VERTICES
	xmlNodeValueReader = ioXmlReadMeshEditComponentNode
	xmlNodeValueWriter = ioXmlWriteMeshEditComponentNode

registerFieldType( MeshEditComponent, MeshEditComponentField )
