##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.Math.Math import Colour3f

from gSculpt.Model import ModelDraw

from gSculpt.MeshTools.MeshToolsetWithPicking import MeshToolsetWithPicking
from gSculpt.MeshTools.MeshEditEdgeToolGroup import MeshEditEdgeToolGroup

from gSculpt.MeshTools.Mark.ToolMeshMarkPickEdges import ProcMeshMarkPickEdges



class MeshEditEdgeToolset (MeshToolsetWithPicking):
	class EdgePick (MeshToolsetWithPicking.MeshPick):
		def __init__(self, toolset):
			super( MeshEditEdgeToolset.EdgePick, self ).__init__( toolset )
			self._bMarked = False
			self._edgeSegment = None


		def _p_refreshHit(self, viewport, mesh, pick):
			edgeIndex, closestPoint, thruFaceIndex = mesh.pickEdge( pick.toMPick() )

			if edgeIndex != -1:
				self._edgeSegment = mesh.getEdgeSegment( edgeIndex )
				self._bMarked = mesh.isEdgeMarked( edgeIndex )
				return True
			else:
				self._edgeSegment = None
				self._bMarked = False
				return False


		def _p_paintHighlight(self, viewport, paintLayer):
			if self._bMarked:
				ModelDraw.drawEdgePickHighlight( self._edgeSegment, ModelDraw.MARKED_TARGET_HIGHLIGHT_COLOUR, paintLayer );
			else:
				ModelDraw.drawEdgePickHighlight( self._edgeSegment, ModelDraw.TARGET_HIGHLIGHT_COLOUR, paintLayer );



	def __init__(self, nodeEditor):
		super( MeshEditEdgeToolset, self ).__init__( _( 'Edges' ), nodeEditor )
		meshEditEdgeGroup = MeshEditEdgeToolGroup( nodeEditor )
		self.addToolGroup( meshEditEdgeGroup )


	def _p_createMeshPick(self):
		return MeshEditEdgeToolset.EdgePick( self )


	def _p_getPickProcedureType(self):
		return ProcMeshMarkPickEdges
