##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.ProceduralTool.GSSceneNodeToolbox import GSSceneNodeToolboxWithNodeViewEditor

from gSculpt.MeshTools.MeshEditToolkit import MeshEditToolkit
from gSculpt.Mesh.GSSceneNodeMeshViewSettings import GSSceneNodeMeshViewSettings, GSSceneNodeMeshViewSettingsEditor



class MeshToolbox (GSSceneNodeToolboxWithNodeViewEditor):
	nodeViewSettingsClass = GSSceneNodeMeshViewSettings
	nodeViewSettingsEditorClass = GSSceneNodeMeshViewSettingsEditor

	def __init__(self, acceleratorManager, view, nodeEditor):
		super( MeshToolbox, self ).__init__( _( 'Mesh' ), acceleratorManager, view )
		meshEditToolkit = MeshEditToolkit( nodeEditor )
		self.addToolkit( meshEditToolkit, _( 'Mesh edit' ) )

