##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.Kernel.DBEdit import BasicColumnWidgetEditor

from MarkPredicateVarEditor import MarkPredicateVarEditRadioGroup



# Variable editor factory for MarkPredicate

class MarkPredicateColumnEditRadioGroup (BasicColumnWidgetEditor):
	def __init__(self, fieldColumn):
		super( MarkPredicateColumnEditRadioGroup, self ).__init__( [ 'mark', 'unmark', 'add', 'filter', 'invert' ] )
		self._fieldColumn = fieldColumn


	def createElement(self, rowEditContext):
		return MarkPredicateVarEditRadioGroup()

	def initialiseElement(self, element, rowEditContext):
		super( MarkPredicateColumnEditRadioGroup, self ).initialiseElement( element, rowEditContext )
		field = self._p_getVar( self._fieldColumn, rowEditContext )
		element.attachVariable( field )

	def shutdownElement(self, element, rowEditContext):
		super( MarkPredicateColumnEditRadioGroup, self ).shutdownElement( element, rowEditContext )
		element.detachVariable()

