##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.Kernel.DBEdit import BasicColumnWidgetEditor

from TargetListVarEditor import TargetListVarEditor


class TargetListColumnEditor (BasicColumnWidgetEditor):
	def __init__(self, fieldColumn, targetLabelText=_( '%d target' ), pluralTargetLabelText=_( '%d targets' ), removeTargetButtonText=_( 'Remove target' )):
		super( TargetListColumnEditor, self ).__init__( [ 'numTargets', 'removeTarget' ] )
		self._fieldColumn = fieldColumn
		self._targetLabelText = targetLabelText
		self._pluralTargetLabelText = pluralTargetLabelText
		self._removeTargetButtonText = removeTargetButtonText

	def createElement(self, rowEditContext):
		return TargetListVarEditor( self._targetLabelText, self._pluralTargetLabelText, self._removeTargetButtonText )

	def initialiseElement(self, element, rowEditContext):
		super( TargetListColumnEditor, self ).initialiseElement( element, rowEditContext )
		field = self._p_getVar( self._fieldColumn, rowEditContext )
		element.attachVariable( field )
		if rowEditContext.commandHistory is not None:
			element.commandHistory = rowEditContext.commandHistory

	def shutdownElement(self, element, rowEditContext):
		super( TargetListColumnEditor, self ).shutdownElement( element, rowEditContext )
		element.detachVariable()
		element.commandHistory = None
