##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.CommandHistory import CommandHistory
from gSculpt.CommandHistory.CommandTracker import CommandTracker

from gSculpt.GSGraph.GSGraphCommandTracker import GSGraphCommandTracker

from GSSceneNodeCommandTracker import GSSceneNodeCommandTracker
from GSFunctionGraphCommandTracker import GSFunctionGraphCommandTracker

from gSculpt.View.BackgroundImageCommandTracker import BackgroundImageListCommandTracker

import GSScene





class GSSceneCommandTracker (GSFunctionGraphCommandTracker):
	def track(self, scene):
		super( GSSceneCommandTracker, self ).track( scene )
		assert isinstance( scene, GSScene.GSScene )

		self._commandHistory.track( scene.graph )
		self._commandHistory.track( scene.backgroundImages )
		self._commandHistory.track( scene.layerTable )


	def stopTracking(self, scene):
		assert isinstance( scene, GSScene.GSScene )

		self._commandHistory.stopTracking( scene.layerTable )
		self._commandHistory.stopTracking( scene.backgroundImages )
		self._commandHistory.stopTracking( scene.graph )

		super( GSSceneCommandTracker, self ).stopTracking( scene )



