##-*************************
##-* This program is free software; you can use it, redistribute it and/or modify it
##-* under the terms of the GNU General Public License version 2 as published by the
##-* Free Software Foundation. The full text of the GNU General Public License
##-* version 2 can be found in the file named 'COPYING' that accompanies this
##-* program. This source code is (C)copyright Geoffrey French 1999-2007.
##-*************************
from gSculpt.Kernel.DBEdit import BasicColumnWidgetEditor

from TextureRefVar import TextureRefVarEditChooser


# Column editor for TextureRef

class TextureRefColumnEditorChooser (BasicColumnWidgetEditor):
	def __init__(self, fieldColumn, chooserDialogTitle):
		super( TextureRefColumnEditorChooser, self ).__init__( [ 'chooser' ] )
		self._fieldColumn = fieldColumn
		self._chooserDialogTitle = chooserDialogTitle


	def createElement(self, rowEditContext):
		return TextureRefVarEditChooser( rowEditContext.parentWindow, self._chooserDialogTitle )

	def initialiseElement(self, element, rowEditContext):
		super( TextureRefColumnEditorChooser, self ).initialiseElement( element, rowEditContext )
		field = self._p_getVar( self._fieldColumn, rowEditContext )
		element.attachVariable( field )

	def shutdownElement(self, element, rowEditContext):
		super( TextureRefColumnEditorChooser, self ).shutdownElement( element, rowEditContext )
		element.detachVariable()
